<?php
session_start(); 
/*File: csl-editor_required.php 
Created by: Alberto Gonzalez, Ricardo Campos and Francisco Zanon
*/
/**
*
* Este archivo contiene una libreria que se encarga de  las tareas de creacin de modulos/Editores para el CSLEditor.
* Se encarga de gestionar las variables que son usadas por la aplicacin y quee deben aparecer en todos los editores.
*
* Para un editor bsico se necesita crear dos archivos php.
* El editor en s y el que se encarga de realizar las operaciones de guardado.
* 
* Por ejemplo para un nodo que solo se encargara de gestionar el nombre del nodo, seria suficiente con generar este codigo para los dos archivos mencionados anteriormente.
*
* Ediotor.php :
*  
*	require("csl-editor_required.php");
*	$save_php = "Guardar.php";  
*  	csl_init();
*  	csl_add_vars($vector,$save_php);
*	
* Guardar.php
*
* require("csl-editor_required.php");
*  csl_check_names();
*  csl_access_control();
*  csl_send_reply("Editor.php");
*
* @package CSLEditor
*
* @author Alberto Gonzalec Cristiano,Ricardo Campos Garcia, Francisco Zanon Ordoez.
*
* @copyright.
*
* @version Beta
**/
include_once("NodosClass.php"); 

session_register('padre');
session_register('nombre');
session_register('ManifestId');
session_register('recurso');

/**
* refresca_arbol()
*
* Funcin que se encarga de recargar el rbol despus de una operacin en la que se aade, elimina o se modifica algn nodo.
**/

function refresca_arbol()
{
	echo "<form name='envia' action='left.php' target='leftFrame' method='post'>";
	echo "<input name='devuelto' type='hidden' value='".$_SESSION['ManifestId']."'</form>";
	echo "<script>document.forms.envia.submit();</script>";
}
/**
*
*csl_init()
*
*Funcin a utilizar por los editores de nodos que se encarga de inicializar las variables necesarias para el correcto funcionamiento del CSL-Editor.
*
*
**/
function csl_init()
{
	global $nombre; global $recurso; global $nombre_orig; global $padre;
	
	
	if ($_POST['ManifestId']!="")
	{
		$nodo=new NodoClass();
   		$nodo->extraeNodoPorManiId($_POST['ManifestId']);
	
		$_SESSION['nombre']=$nodo->Nombre;
		$padre=$_SESSION['nombre'];
		$nombre_orig=$_SESSION['nombre'];
		listar_directorios_ruta("./");
	}
	else
	{
		$padre = $_SESSION['padre'];
		$recurso = $_POST['recurso'];
		if ($_POST['nombre']!="")
			$_SESSION['nombre'] = $_POST['nombre'];
		$nombre_orig = $_SESSION['nombre'];
		
	}
	

}
/**
*
*csl_add_vars($vector,$save_php)
*
*Funcin que se encarga de aadir el formulario que se enviar al realizar al utilizar el botn de guardar de la barra superior. 
*
*Las variables que se aaden automticamente son:
*
*nombre: Se presenta como un campo de texto en el cual se puede modificar el nombre del nodo.
*nombre_original: Se utiliza por otras funciones del CSL-Editor para comprobar si hemos modificado el nombre al nodo. 
*
*Toma dos parmetros:
*
*$vector:es un vector de strings que se utiliza para que el desarrollador de mdulos pueda pasar variables de su editor al archivo que utiliza para realizar las operaciones de guardado. Cada uno de los elementos del Array esta compuesto por nombre de la variable, valor de la variable y tipo de control de formulario necesario para su edicin; por ejemplo: 
*
*		$vector[0] = variable1.valor1.textarea;
*
* $save_php: se encarga de definir cual es el archivo php que se utiliza para realizar las operaciones de guardado.
* @param Array $vector es un vector de strings que se utiliza para que el desarrollador de mdulos pueda pasar variables de su editor al archivo que utiliza para realizar las operaciones de guardado. Cada uno de los elementos del Array esta compuesto por nombre de la variable, valor de la variable y tipo de control de formulario necesario para su edicin; por ejemplo.
* @param String $save_php se encarga de definir cual es el archivo php que se utiliza para realizar las operaciones de guardado.
*
**/

function csl_add_vars($vector,$save_php)
{
	global $nombre; global $recurso; global $nombre_orig;
	/*echo "<script>alert('Manifest: ".$_SESSION['ManifestId']."');</script>";*/
	$nodo=new NodoClass();
   	$nodo->extraeNodoPorManiId($_SESSION['ManifestId']);
	$count=0;
	if ($nodo->ArrayRecursos!=null)
	{
		foreach ($nodo->ArrayRecursos as $a=>$b)
		{
			$recurso[$count]=$b;
			$count++;
		}
	}
  	/*echo "<script>alert('Recurso: ".$recurso[0]."');</script>";*/
	$_SESSION['recurso']=$recurso;
  echo "<form name='formul' action='".$save_php."' method='post' target='mainFrame'>";
  echo "Nombre: <input type='text' name='nombre' value='".$nombre."'><br /><br />";
  for($i=0;$i<count($vector);$i++)
  {
    $aux = explode(".",$vector[$i]);
	if($aux[2]=="textarea")
  		echo $aux[0].": <textarea name='".$aux[0]."'>".$aux[1]."</textarea>"; 	
	else 
		if ($aux[2]=="hidden")
			echo "<input type='hidden' name='".$aux[0]."' value='".$aux[1]."'>";
	/*	else
			echo "<input type='".$aux[2]."' name='".$aux[0]."' value='".$aux[1]."'>";*/
  }
  
  echo "<input type='hidden' name='nombre_orig' value='".$nombre_orig."'></input>";
  echo "</form>";
}

/**
*
*listar_directorios_ruta($ruta)
*
*Funcin que se utiliza para listar recursivamente todos los subdirectorios y archivos dentro de la ruta pasada como parmetro. 
*
*$ruta: define cual es el directorio a partir del cual comenzamos a listar.
* @param String $ruta define cual es el directorio a partir del cual comenzamos a listar.
**/

//funcion para buscar un directorio
function listar_directorios_ruta($ruta)
{
	global $padre;
   	// abrir un directorio y listarlo recursivo
	
   	if (is_dir($ruta)) 
	{
		if ($dh = opendir($ruta)) 
		{
         	while (($file = readdir($dh)) !== false) 
			{
            	//esta lnea la utilizaramos si queremos listar todo lo que hay en el directorio
            	//mostrara tanto archivos como directorios
            	//echo "<br>Nombre de archivo: $file : Es un: " . filetype($ruta . $file);
            	if (is_dir($ruta . $file) && $file!="." && $file!="..")
				{
               		//solo si el archivo es un directorio, distinto que "." y ".."
			   		if ($file==$padre)
			   		{
						$padre=$ruta.$file;
						$_SESSION['padre']=$padre;
					}
               listar_directorios_ruta($ruta . $file . "/");
            }
         }
      closedir($dh);
      }
   }else
      echo "<br>No es ruta valida";
} 
/**
*
* csl_check_node()
*
* Funcin utilizada en las operaciones de creacin de un nuevo nodo que controla que se no exista un nodo con el mismo nombre 
* Adems de ocuparse de la creacin de sus carpetas.
*
**/

function csl_check_node()
{
	global $recurso; global $nombre; global $nombre_orig; global $padre;
 
  	listar_directorios_ruta("./");
	
	//compruebo si existe el nodo
 	$existe=false;
 	$directorio=opendir($_SESSION['padre']);
 	while ($archivo = readdir($directorio))
 	{
 		/*echo "<script>alert('Leo: ".$archivo."');</script>";*/
		/*echo "<script>alert('Nombre: ".$_SESSION['nombre']."');</script>";*/
 		if ($archivo == $_SESSION['nombre'])
			$existe=true;
	}
	
	if ($existe==false)
 	{
 		/*echo "<script>alert('Carpeta: ".$_SESSION['padre']."/".$_SESSION['nombre']."');</script>";*/
 		mkdir($_SESSION['padre']."/".$_SESSION['nombre'],0700);
		return false;
	}
 	else if ($existe==true)
 	{
		return true;
 	}
}

/** 
*
* csl_check_names()
*
* Funcin que se encarga de comprobar, en el archivo de guardado definido por el usuario, si se ha modificado el nombre del nodo. 
* En caso afirmativo crea la nueva carpeta del nodo, copia todos los recursos y se elimina la carpeta antigua. 
*
*
**/

function csl_check_names()
{
 global $recurso; global $nombre; global $nombre_orig; global $padre;

 $nombre_orig=$_POST['nombre_orig'];
 //creo la carpeta que contendr el nuevo nodo
 $nombre=$_POST['nombre'];
 if($nombre_orig != $nombre)
 {
 	mkdir(ereg_replace($nombre_orig,$_POST['nombre'],$_SESSION['padre'])."/",0700);
 	copiar_directorios($_SESSION['padre']);
	borrar_directorios($_SESSION['padre']);
 	/*echo "<script>alert('Kiero cambiar: ".$nombre_orig." por: ".$_POST['nombre']."Nombre orig: ".$_POST['nombre_orig']."');</script>";*/
 	$_SESSION['padre']=ereg_replace($nombre_orig,$_POST['nombre'],$_SESSION['padre']);
   
   $n = count($recurso);
   $i = 0;
   while ($i < $n)
   {
   		$vector=explode(".",$recurso[$i]);
		if ($vector[0]==$nombre_orig)
		{
			$recurso[$i]=$nombre.".".$vector[1];
    		rename($_SESSION['padre']."/".$vector[0].".".$vector[1],$_SESSION['padre']."/".$recurso[$i]);
		}
		$i++;
   }
 }
 $oldN=new NodoClass();
	  $oldN->extraeNodoPorManiId($_SESSION['ManifestId']);
	  $oldN->Nombre=$nombre;
	  $oldN->Save();
	  
	refresca_arbol();

}
/**
*
*csl_access_control()
*
*Funcin que se puede utilizar en el archivo de guardado para comprobar que no se accede de manera directa a este sin haberle pasado las variables necesarias para el guardar. 
*
**/

function csl_access_control()
{
 global $recurso; global $nombre;
 /*if($nombre == "" || $recurso=="")
 {
  echo "<script>alert('ERROR');</script>";
  echo "<form name='error' action='asdsdaad.h' method='post'></form>";//MODIFICAR
  echo"<script>document.error.submit();</script>";
 }*/
}
/**
*
* csl_send_reply($action)
*
* Funcin que se encarga de devolver, despus de las operaciones de guardado al editor que se le pasa como parmetro. 
*
* $action: parmetro que se encarga de definir cual es el archivo al cual debemos volver despus de realizar las acciones de guardado. 
* @param String $action parmetro que se encarga de definir cual es el archivo al cual debemos volver despus de realizar las acciones de guardado. 
**/

function csl_send_reply($action)
{
 global $nombre;
 echo "<form action='".$action."' target='mainFrame' name='ok' method='post'><input type='hidden' name='guardado_ok' value='ok'>";
 echo"<input type='hidden' name='nombre' value='".$nombre."'></form>";
 echo "<script>document.ok.submit();</script>";
}
/**
*
*
*  csl_add_resource($nombre)
*
*   Funcin que se debe utilizar despus de aadir un nuevo recurso, definido por el parmetro, a nuestro nodo para modificar los archivos xml donde esta definido. 
*
*	$nombre: nombre del nuevo recurso asociado a nuestro nodo.
*  @param String  $nombre nombre del nuevo recurso asociado a nuestro nodo.
**/

function csl_add_resource($nombre)
{
	$nodo=new NodoClass();
   	$nodo->extraeNodoPorManiId($_SESSION['ManifestId']);
	$nodo->AddRecurso($nombre);
	$nodo->SaveResources();
}
/**
*
* borrar_directorios($ruta)
*
* Funcin que se utiliza para borrar recursivamente todos los subdirectorios y archivos dentro de la ruta pasada como parmetro. 
*
* $ruta: define cual es el directorio a partir del cual comenzamos a borrar.
* @param String $ruta define cual es el directorio a partir del cual comenzamos a borrar.
**/

function borrar_directorios($ruta)
{
	global $padre;
   	// abrir un directorio y listarlo recursivo
   	if (is_dir($ruta)) 
	{
		if ($dh = opendir($ruta)) 
		{
         	while (($file = readdir($dh)) !== false) 
			{
				/*echo "<script>alert('Archivo: ".$ruta."/".$file."');</script>";*/
            	//esta lnea la utilizaramos si queremos listar todo lo que hay en el directorio
            	//mostrara tanto archivos como directorios
            	//echo "<br>Nombre de archivo: $file : Es un: " . filetype($ruta . $file);
            	if (is_dir($ruta ."/". $file) && $file!="." && $file!="..")
				{
					/*echo "<script>alert('Archivo: ".$ruta."/".$file." es directorio');</script>";*/
               		//solo si el archivo es un directorio, distinto que "." y ".."
               		borrar_directorios($ruta ."/". $file . "/");
					
            	}
				else if($file!="." && $file!="..")
				{
					/*echo "<script>alert('Archivo: ".$ruta.$file." es fichero');</script>";*/
					unlink($ruta."/".$file);
				}
         	}
			closedir($dh);
			rmdir($ruta."/".$file);
      	}
   	}else
      echo "<br>No es ruta valida";
} 
/**
*
* copiar_directorios($ruta)
*
* Funcin que se utiliza para copiar recursivamente todos los subdirectorios y archivos dentro de la ruta pasada como parmetro. 
*
* $ruta: define cual es el directorio a partir del cual comenzamos a copiar.
* @param String $ruta define cual es el directorio a partir del cual comenzamos a copiar.
**/
function copiar_directorios($ruta)
{
	global $padre; global $nombre_orig;
   	// abrir un directorio y listarlo recursivo
   	if (is_dir($ruta)) 
	{
		if ($dh = opendir($ruta)) 
		{
         	while (($file = readdir($dh)) !== false) 
			{
				/*echo "<script>alert('Archivo: ".$ruta."/".$file."');</script>";*/
            	//esta lnea la utilizaramos si queremos listar todo lo que hay en el directorio
            	//mostrara tanto archivos como directorios
            	//echo "<br>Nombre de archivo: $file : Es un: " . filetype($ruta . $file);
            	if (is_dir($ruta ."/". $file) && $file!="." && $file!="..")
				{
               		//solo si el archivo es un directorio, distinto que "." y ".."
					mkdir(ereg_replace($nombre_orig,$_POST['nombre'],$ruta)."/".$file);
               		copiar_directorios($ruta ."/". $file . "/");
					
            	}
				else if($file!="." && $file!="..")
				{
					/*echo "<script>alert('Archivo: ".$ruta.$file." es fichero');</script>";*/
					copy($ruta."/".$file, ereg_replace($nombre_orig,$_POST['nombre'],$ruta)."/".$file);
				}
         	}
			closedir($dh);
			//rmdir($ruta."/".$file);
      	}
   	}else
      echo "<br>No es ruta valida";
} 

/**
*
**/

function listar_directorios($ruta){
   // abrir un directorio y listarlo recursivo
   if (is_dir($ruta)) {
      if ($dh = opendir($ruta)) {
         while (($file = readdir($dh)) !== false) {
            //esta lnea la utilizaramos si queremos listar todo lo que hay en el directorio
            //mostrara tanto archivos como directorios
            //echo "<br>Nombre de archivo: $file : Es un: " . filetype($ruta . $file);
            if (is_dir($ruta . $file) && $file!="." && $file!=".."){
               //solo si el archivo es un directorio, distinto que "." y ".."
               echo "<br>Directorio: $ruta$file";
               listar_directorios($ruta . $file . "/");
            }
			else
			{
				echo "<br>Archivo: $ruta$file";
			}
         }
      closedir($dh);
      }
   }else
      echo "<br>No es ruta valida";
} 
?>